<?php
/**
 * Settings page online table.
 *
 * @package Spam Master
 */

global $wpdb, $blog_id;
$plugin_master_name   = constant( 'SPAM_MASTER_NAME' );
$plugin_master_domain = constant( 'SPAM_MASTER_DOMAIN' );
?>

<div class="spam-master-pad-table"></div>

<table class="wp-list-table widefat fixed striped table-view-list" cellspacing="0">
	<thead>
		<tr>
			<th><h2><img class="spam-master-admin-img" src="<?php echo esc_url( plugins_url( '../images/spammaster-logo.png', dirname( __FILE__ ) ) ); ?>" /><?php echo esc_attr( __( '&nbsp;Firewall & Advanced Statistics', 'spam-master' ) ); ?></h2></th>
		</tr>
	</thead>

	<tfoot>
		<tr>
			<th>
				<a class="btn-spammaster orange roundedspam spam-master-text-center" href="https://www.spammaster.org" target="_blank" title="<?php echo esc_attr( __( 'www.spammaster.org', 'spam-master' ) ); ?>">
					<?php echo esc_attr( __( 'Register & Login: ', 'spam-master' ) ); ?><strong><?php echo esc_attr( $spam_master_attached ); ?></strong>
				</a>
			</th>
		</tr>
	</tfoot>

	<tbody>
		<tr class="alternate">
			<td>
				<span class="dashicons dashicons-info" title="Test Email To Be Used In Forms"></span> <?php echo esc_attr( __( 'Test your website spam submission on any form using the email', 'spam-master' ) ); ?> <strong><?php echo esc_attr( __( 'spam_email@example.com', 'spam-master' ) ); ?></strong>.
			</td>
		</tr>
		<tr class="alternate">
			<td>
				<span class="dashicons dashicons-info" title="Spam Master Info"></span> <?php echo esc_attr( __( 'You can interact with your Firewall, Tools & Statistics at', 'spam-master' ) ); ?> <a href="https://www.spammaster.org" title="<?php echo esc_attr( __( 'Spam Master Website', 'spam-master' ) ); ?>" target="_blank"><?php echo esc_attr( __( 'www.spammaster.org', 'spam-master' ) ); ?></a>. <?php echo esc_attr( __( 'Use the email attached to your key to Register & Login', 'spam-master' ) ); ?>. <span class="dashicons dashicons-email-alt" title="Email to use during Registration or Login"></span> <?php echo esc_attr( __( 'Attached Email:', 'spam-master' ) ); ?> <strong><?php echo esc_attr( $spam_master_attached ); ?></strong>. <?php echo esc_attr( __( 'You may also create an account with another email and transfer', 'spam-master' ) ); ?> <span class="dashicons dashicons-randomize" title="Transfer key to another email"></span> <?php echo esc_attr( __( 'the key to it.', 'spam-master' ) ); ?>
			</td>
		</tr>
	</tbody>
</table>
