<?php
/**
 * Collect controller
 *
 * @package Spam Master
 */

/**
 * Main collect class.
 *
 * @since 6.0.0
 */
class SpamMasterCollectController {

	/**
	 * Variable collect_now.
	 *
	 * @var collect_now $collect_now
	 **/
	protected $collect_now;

	/**
	 * Spam master get collect.
	 *
	 * @param collect_now $collect_now for collection.
	 *
	 * @return array
	 */
	public function spammastergetcollect( $collect_now ) {
		global $wpdb, $blog_id;

		// Remote Ip.
		if ( isset( $_SERVER['REMOTE_ADDR'] ) ) {
			$remote_ip = substr( sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ), 0, 48 );
		} else {
			$remote_ip = 'I 666';
		}
		// Remote Agent.
		if ( isset( $_SERVER['HTTP_USER_AGENT'] ) ) {
			$remote_agent = substr( sanitize_text_field( wp_unslash( $_SERVER['HTTP_USER_AGENT'] ) ), 0, 360 );
		} else {
			$remote_agent = 'Sniffer';
		}
		// Remote Referer.
		if ( isset( $_SERVER['HTTP_REFERER'] ) ) {
			$remote_referer = substr( esc_url_raw( wp_unslash( $_SERVER['HTTP_REFERER'] ) ), 0, 360 );
		} else {
			$remote_referer = 'Direct';
		}
		// DEST URL.
		if ( isset( $_SERVER['REQUEST_SCHEME'] ) ) {
			$spam_request_scheme = sanitize_text_field( wp_unslash( $_SERVER['REQUEST_SCHEME'] ) );
		} else {
			$spam_request_scheme = 'false';
		}
		if ( isset( $_SERVER['SERVER_NAME'] ) ) {
			$spam_server_name = sanitize_text_field( wp_unslash( $_SERVER['SERVER_NAME'] ) );
		} else {
			$spam_server_name = 'false';
		}
		if ( isset( $_SERVER['REQUEST_URI'] ) ) {
			$spam_request_uri = sanitize_text_field( wp_unslash( $_SERVER['REQUEST_URI'] ) );
		} else {
			$spam_request_uri = '/false';
		}
		$dest_url = substr( $spam_request_scheme . '://' . $spam_server_name . $spam_request_uri, 0, 360 );

		return array(
			'remote_ip'      => $remote_ip,
			'remote_agent'   => $remote_agent,
			'remote_referer' => $remote_referer,
			'dest_url'       => $dest_url,
		);
	}

}

