<?php
/**
 * Load spam master contact form 7.
 *
 * @package Spam Master
 */

global $wpdb, $blog_id;
// Add Table & Load Spam Master Options.
if ( is_multisite() ) {
	$spam_master_keys = $wpdb->get_blog_prefix( $blog_id ) . 'spam_master_keys';
} else {
	$spam_master_keys = $wpdb->prefix . 'spam_master_keys';
}
// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
$spam_master_status = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_status'" );

if ( 'VALID' === $spam_master_status || 'MALFUNCTION_1' === $spam_master_status || 'MALFUNCTION_2' === $spam_master_status ) {

	/**
	 * Spam master contact form 7 learning.
	 *
	 * @param spam $spam for learning.
	 *
	 * @return spam|false
	 */
	function spam_master_contact_form_7( $spam ) {
		global $wpdb, $blog_id;
		// buffer action.
		if ( $spam ) {
			return $spam;
		}

		// Add Table & Load Spam Master Options.
		if ( is_multisite() ) {
			$spam_master_keys = $wpdb->get_blog_prefix( $blog_id ) . 'spam_master_keys';
		} else {
			$spam_master_keys = $wpdb->prefix . 'spam_master_keys';
		}
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$spam_master_alert_level = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_alert_level'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$spam_master_message = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'spam_master_message'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$contact_text_override = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'contact_text_override'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$contact_russian_char = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'contact_russian_char'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$contact_chinese_char = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'contact_chinese_char'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$contact_asian_char = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'contact_asian_char'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$contact_arabic_char = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'contact_arabic_char'" );
		// phpcs:ignore WordPress.DB.DirectDatabaseQuery.DirectQuery, WordPress.DB.DirectDatabaseQuery.NoCaching, WordPress.DB.PreparedSQL.InterpolatedNotPrepared
		$contact_spam_char = $wpdb->get_var( "SELECT spamvalue FROM {$spam_master_keys} WHERE spamkey = 'Option' AND spamtype = 'contact_spam_char'" );

		// Spam Master page.
		$spam_master_page = 'Contact Form';
		// Spam Type.
		$spamtype = $spam_master_page;
		// Spam Initial.
		$spaminitial = 'contact';

		// Spam Collect Controller.
		$spam_master_collect_controller = new SpamMasterCollectController();
		$collect_now                    = true;
		$is_collected                   = $spam_master_collect_controller->spammastergetcollect( $collect_now );

		// Spam User Controller.
		$spam_master_user_controller = new SpamMasterUserController();
		// phpcs:ignore WordPress.Security.NonceVerification.Missing
		if ( ! empty( $_POST['your-email'] ) ) {
			// phpcs:ignore WordPress.Security.NonceVerification.Missing
			if ( filter_var( wp_unslash( $_POST['your-email'] ), FILTER_VALIDATE_EMAIL ) ) {
				// phpcs:ignore WordPress.Security.ValidatedSanitizedInput.InputNotSanitized, WordPress.Security.NonceVerification.Missing
				$spampreemail = wp_strip_all_tags( substr( wp_unslash( $_POST['your-email'] ), 0, 256 ) );
			} else {
				$spampreemail = false;
			}
		} else {
			$spampreemail = false;
		}
		$is_user = $spam_master_user_controller->spammastergetuser( $spaminitial, $spampreemail );

		// phpcs:ignore WordPress.Security.NonceVerification.Missing
		if ( ! empty( $_POST['your-message'] ) ) {
			// phpcs:ignore WordPress.Security.ValidatedSanitizedInput.InputNotSanitized, WordPress.Security.NonceVerification.Missing
			$result_comment_content_trim  = substr( wp_unslash( $_POST['your-message'] ), 0, 360 );
			$result_comment_content_clean = wp_strip_all_tags( stripslashes_deep( $result_comment_content_trim ), true );
		} else {
			$result_comment_content_clean = 'your-message';
		}

		// Spam White Controller.
		$spamtype                     = $spam_master_page;
		$spam_master_white_controller = new SpamMasterWhiteController();
		$is_spamadmin                 = $spam_master_white_controller->spammasterwhiteadmin( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spamtype );
		if ( ! empty( $is_spamadmin ) ) {
			return false;
		}

		// Spam White Controller.
		$spamtype                     = $spam_master_page;
		$spam_master_white_controller = new SpamMasterWhiteController();
		$is_white                     = $spam_master_white_controller->spammasterwhitesearch( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spamtype );
		if ( ! empty( $is_white ) ) {
			return false;
		}

		// Spam Buffer Controller.
		$spam_master_buffer_controller = new SpamMasterBufferController();
		$is_buffer                     = $spam_master_buffer_controller->spammasterbuffersearch( $is_collected['remote_ip'], $is_user['blog_threat_email'] );
		if ( ! empty( $is_buffer ) ) {
			// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
			return $result['reason'] = array( 'date_too_late' => wpcf7_get_message( 'date_too_late' ) );
		}

		// lets do a quick character block.
		$comment_russian_char = false;
		$comment_chinese_char = false;
		$comment_asian_char   = false;
		$comment_arabic_char  = false;
		$comment_spam_char    = false;

		if ( 'true' === $contact_russian_char ) {
			// Spam ComCon Controller.
			$spam_master_com_con_controller = new SpamMasterComConController();
			$is_char                        = $spam_master_com_con_controller->spammastercharscan( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spam_master_page, $result_comment_content_clean, $comment_russian_char, $comment_chinese_char, $comment_asian_char, $comment_arabic_char, $comment_spam_char, $contact_russian_char, $contact_chinese_char, $contact_asian_char, $contact_arabic_char, $contact_spam_char );
			if ( $is_char ) {
				// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
				return $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
			}
		}
		if ( 'true' === $contact_chinese_char ) {
			// Spam ComCon Controller.
			$spam_master_com_con_controller = new SpamMasterComConController();
			$is_char                        = $spam_master_com_con_controller->spammastercharscan( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spam_master_page, $result_comment_content_clean, $comment_russian_char, $comment_chinese_char, $comment_asian_char, $comment_arabic_char, $comment_spam_char, $contact_russian_char, $contact_chinese_char, $contact_asian_char, $contact_arabic_char, $contact_spam_char );
			if ( $is_char ) {
				// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
				return $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
			}
		}
		if ( 'true' === $contact_asian_char ) {
			// Spam ComCon Controller.
			$spam_master_com_con_controller = new SpamMasterComConController();
			$is_char                        = $spam_master_com_con_controller->spammastercharscan( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spam_master_page, $result_comment_content_clean, $comment_russian_char, $comment_chinese_char, $comment_asian_char, $comment_arabic_char, $comment_spam_char, $contact_russian_char, $contact_chinese_char, $contact_asian_char, $contact_arabic_char, $contact_spam_char );
			if ( $is_char ) {
				// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
				return $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
			}
		}
		if ( 'true' === $contact_arabic_char ) {
			// Spam ComCon Controller.
			$spam_master_com_con_controller = new SpamMasterComConController();
			$is_char                        = $spam_master_com_con_controller->spammastercharscan( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spam_master_page, $result_comment_content_clean, $comment_russian_char, $comment_chinese_char, $comment_asian_char, $comment_arabic_char, $comment_spam_char, $contact_russian_char, $contact_chinese_char, $contact_asian_char, $contact_arabic_char, $contact_spam_char );
			if ( $is_char ) {
				// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
				return $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
			}
		}
		if ( 'true' === $contact_spam_char ) {
			// Spam ComCon Controller.
			$spam_master_com_con_controller = new SpamMasterComConController();
			$is_char                        = $spam_master_com_con_controller->spammastercharscan( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spam_master_page, $result_comment_content_clean, $comment_russian_char, $comment_chinese_char, $comment_asian_char, $comment_arabic_char, $comment_spam_char, $contact_russian_char, $contact_chinese_char, $contact_asian_char, $contact_arabic_char, $contact_spam_char );
			if ( $is_char ) {
				// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
				return $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
			}
		}

		// Spam ComCon Controller.
		$spam_master_com_con_controller = new SpamMasterComConController();
		$is_comcon                      = $spam_master_com_con_controller->spammastercomconscan( $is_collected['remote_ip'], $is_user['blog_threat_email'], $is_collected['remote_referer'], $is_collected['dest_url'], $is_collected['remote_agent'], $is_user['spamuserA'], $spam_master_page, $result_comment_content_clean );
		if ( $is_comcon ) {
			// phpcs:ignore Squiz.PHP.DisallowMultipleAssignments.Found
			return $result['reason'] = array( 'spam' => wpcf7_get_message( 'spam' ) );
		} else {
			return false;
		}
		// end function.
	}
	add_filter( 'wpcf7_spam', 'spam_master_contact_form_7' );
	// end valid.
}

